CodeForces 316c1 Tidying Up

Tidying Up

Time Limit: 4000ms

Memory Limit: 262144KB

This problem will be judged on CodeForces. Original ID: 316C1
64-bit integer IO format: %I64d      Java class name: (Any)

Smart Beaver is careful about his appearance and pays special attention to shoes so he has a huge number of pairs of shoes from the most famous brands of the forest. He‘s trying to handle his shoes carefully so that each pair stood side by side. But by the end of the week because of his very active lifestyle in his dressing room becomes a mess.

Smart Beaver from ABBYY is not only the brightest beaver in the area, but he also is the most domestically oriented. For example, on Mondays the Smart Beaver cleans everything in his home.

It‘s Monday morning. Smart Beaver does not want to spend the whole day cleaning, besides, there is much in to do and it’s the gym day, so he wants to clean up as soon as possible. Now the floors are washed, the dust is wiped off — it’s time to clean up in the dressing room. But as soon as the Smart Beaver entered the dressing room, all plans for the day were suddenly destroyed: chaos reigned there and it seemed impossible to handle, even in a week. Give our hero some hope: tell him what is the minimum number of shoes need to change the position to make the dressing room neat.

The dressing room is rectangular and is divided into n × m equal squares, each square contains exactly one shoe. Each pair of shoes has a unique number that is integer from 1 to , more formally, a square with coordinates (i, j) contains an integer number of the pair which is lying on it. The Smart Beaver believes that the dressing room is neat only when each pair of sneakers lies together. We assume that the pair of sneakers in squares (i1, j1) and (i2, j2) lies together if |i1 - i2| + |j1 - j2| = 1.

Input

The first line contains two space-separated integers n and m. They correspond to the dressing room size. Next n lines contain m space-separated integers each. Those numbers describe the dressing room. Each number corresponds to a snicker.

It is guaranteed that:

  • n·m is even.
  • All numbers, corresponding to the numbers of pairs of shoes in the dressing room, will lie between 1 and .
  • Each number from 1 to  will occur exactly twice.

The input limits for scoring 30 points are (subproblem C1):

  • 2 ≤ n, m ≤ 8.

The input limits for scoring 100 points are (subproblems C1+C2):

  • 2 ≤ n, m ≤ 80.

Output

Print exactly one integer — the minimum number of the sneakers that need to change their location.

Sample Input

Input

2 31 1 22 3 3

Output

2

Input

3 41 3 2 62 1 5 64 4 5 3

Output

4

Source

ABBYY Cup 3.0

解题:最小费用最大流

 1 #include <bits/stdc++.h>
 2 #define INF 0x3f3f3f3f
 3 const int maxn = 100010;
 4 using namespace std;
 5 struct arc {
 6     int to,flow,next;
 7     int cost;
 8     arc(int x = 0,int y = 0,int z = 0,int nxt = -1) {
 9         to = x;
10         flow = y;
11         cost = z;
12         next = nxt;
13     }
14 };
15 int head[maxn],tot,p[maxn],d[maxn];
16 arc e[1000010];
17 bool in[maxn];
18 void add(int u,int v,int flow,int cost) {
19     e[tot] = arc(v,flow,cost,head[u]);
20     head[u] = tot++;
21     e[tot] = arc(u,0,-cost,head[v]);
22     head[v] = tot++;
23 }
24 bool spfa(int S,int T) {
25     for(int i = 0; i < maxn; i++) {
26         p[i] = -1;
27         d[i] = INF;
28         in[i] = false;
29     }
30     d[S] = 0;
31     queue<int>q;
32     q.push(S);
33     while(!q.empty()) {
34         int u = q.front();
35         q.pop();
36         in[u] = false;
37         for(int i = head[u]; ~i; i = e[i].next) {
38             if(e[i].flow && d[e[i].to] > d[u] + e[i].cost) {
39                 d[e[i].to] = d[u] + e[i].cost;
40                 p[e[i].to] = i;
41                 if(!in[e[i].to]) {
42                     q.push(e[i].to);
43                     in[e[i].to] = true;
44                 }
45             }
46         }
47     }
48     return p[T] > -1;
49 }
50
51 int calc(int S,int T) {
52     int tmp = 0,mxV;
53     while(spfa(S,T)) {
54         mxV = INF;
55         for(int i = p[T]; ~i; i = p[e[i^1].to])
56             mxV = min(mxV,e[i].flow);
57         for(int i = p[T]; ~i; i = p[e[i^1].to]) {
58             e[i].flow -= mxV;
59             e[i^1].flow += mxV;
60             tmp += e[i].cost*mxV;
61         }
62     }
63     return tmp;
64 }
65 int mp[120][120];
66 int main() {
67     int n,m,S,T;
68     while(~scanf("%d%d",&n,&m)) {
69         memset(head,-1,sizeof head);
70         for(int i = tot = 0; i < n; ++i)
71             for(int j = 0; j < m; ++j) {
72                 scanf("%d",mp[i]+j);
73             }
74         S = n*m;
75         T = S + 1;
76         for(int i = 0; i < n; ++i)
77             for(int j = 0; j < m; ++j) {
78                 if((i+j)&1) {
79                     add(S,i*m+j,1,0);
80                     if(i) add(i*m+j,(i-1)*m+j,1,mp[i][j] != mp[i-1][j]);
81                     if(j) add(i*m+j,i*m+j-1,1,mp[i][j] != mp[i][j-1]);
82                     if(i+1 < n)
83                         add(i*m+j,(i+1)*m+j,1,mp[i][j] != mp[i+1][j]);
84                     if(j+1 < m)
85                         add(i*m+j,i*m+j+1,1,mp[i][j] != mp[i][j+1]);
86                 } else add(i*m+j,T,1,0);
87             }
88         printf("%d\n",calc(S,T));
89     }
90     return 0;
91 }

时间: 2024-12-24 08:24:24

CodeForces 316c1 Tidying Up的相关文章

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl

Codeforces 617 E. XOR and Favorite Number

题目链接:http://codeforces.com/problemset/problem/617/E 一看这种区间查询的题目,考虑一下莫队. 如何${O(1)}$的修改和查询呢? 令${f(i,j)}$表示区间${\left [ l,r \right ]}$内数字的异或和. 那么:${f(l,r)=f(1,r)~~xor~~f(1,l-1)=k}$ 记一下前缀异或和即可维护. 1 #include<iostream> 2 #include<cstdio> 3 #include&l

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ